
#include "keyb.h"
#include "mouse.h"
#include "svga.h"

#define MOUSEMU_SPEED_DEFAULT 40

int MOUSEMU_enable = 1;
int MOUSEMU_speed = MOUSEMU_SPEED_DEFAULT;

void MOUSEMU_update (void)
{
  if (MOUSEMU_enable)
  {
    int xplus=SVGA_maxX/MOUSEMU_speed;
    int yplus=SVGA_maxY/MOUSEMU_speed;

    if (MOUSE_installed != MOUSE_INSTALLED)
    {
      if (!KEYB_flags.numLock)
      {
        if (KEYB_pressed (KEY__6))
        {
          if (MOUSE_info.x+xplus <= MOUSE_maxX)
            MOUSE_info.x+=xplus;
          else
            MOUSE_info.x=MOUSE_maxX;
        }
        if (KEYB_pressed (KEY__4))
        {
          if (MOUSE_info.x-xplus >= MOUSE_minX)
          {
            MOUSE_info.x-=yplus;
          }
          else
            MOUSE_info.x=MOUSE_minX;
        }

        if (KEYB_pressed (KEY__2))
        {
          if (MOUSE_info.y+yplus <= MOUSE_maxY)
            MOUSE_info.y+=yplus;
          else
            MOUSE_info.y = MOUSE_maxY;
        }
        if (KEYB_pressed (KEY__8))
        {
          if (MOUSE_info.y-yplus >= MOUSE_minY)
          {
            MOUSE_info.y-=yplus;
          }
          else
            MOUSE_info.y=MOUSE_minY;
        }

        MOUSE_info.buttons.left = (KEYB_pressed (KEY__0) != 0);
        MOUSE_info.buttons.right = (KEYB_pressed (KEY__PERIOD) != 0);
      }
    }
  }
}
